//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property indicator_separate_window
#property  indicator_buffers 7
#property indicator_color1 Green
#property indicator_color2 LimeGreen
#property indicator_color3 PaleVioletRed
#property indicator_color4 HotPink
#property indicator_color5 Silver
#property indicator_color6 Silver
#property indicator_color7 Silver
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    LwmaPeriod       = 56;
extern int    LwmaPrice        = PRICE_CLOSE;
extern int    EmaPeriod        = 10;
extern bool   Interpolate      = true;


//
//
//
//
//

double slope[];
double ema1[];
double ema2[];
double slopeuu[];
double slopeud[];
double slopedu[];
double slopedd[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{      
   IndicatorDigits(6);    
   IndicatorBuffers(7);      
   SetIndexBuffer(0,slopeud); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,slopeuu); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,slopedd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,slopedu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,slope);
   SetIndexBuffer(5,ema1);
   SetIndexBuffer(6,ema2);
   
   //
   //
   //
   //
   //
   
   indicatorFileName = WindowExpertName();
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+" LWMA Slope");
return(0);
}
int deinit()
{
   //deleteArrows();    
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { slopeud[0] = limit+1; return(0); }
           if (timeFrame != Period())
           {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);
                     slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",LwmaPeriod,LwmaPrice,EmaPeriod,4,y);
                     ema1[i]  = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",LwmaPeriod,LwmaPrice,EmaPeriod,5,y);
                     ema2[i]  = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",LwmaPeriod,LwmaPrice,EmaPeriod,6,y);
                     
                      slopeuu[i] = EMPTY_VALUE;
                      slopeud[i] = EMPTY_VALUE;
                      slopedd[i] = EMPTY_VALUE;
                      slopedu[i] = EMPTY_VALUE;
                      if (slope[i]>ema1[i]) slopeuu[i] = slope[i]; 
                      if (slope[i]>0)       slopeud[i] = slope[i]; 
                      if (slope[i]<ema2[i]) slopedu[i] = slope[i];
                      if (slope[i]<0)       slopedd[i] = slope[i];
                     
                      //
                      //
                      //
                      //
                      //
            
                      if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

                      //
                      //
                      //
                      //
                      //

                      datetime time = iTime(NULL,timeFrame,y);
                        for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                        for(int x = 1; x < n; x++) 
                        {
                           slope[i+x] = slope[i] + (slope[i+n] - slope[i])* x/n;
                           ema1[i+x]  = ema1[i]  + (ema1[i+n]  - ema1[i]) * x/n;   
                           ema2[i+x]  = ema2[i]  + (ema2[i+n]  - ema2[i] )* x/n; 
                           if (slopeuu[i]!= EMPTY_VALUE) slopeuu[i+x] = slope[i+x];
                           if (slopeud[i]!= EMPTY_VALUE) slopeud[i+x] = slope[i+x];
                           if (slopedd[i]!= EMPTY_VALUE) slopedd[i+x] = slope[i+x];
                           if (slopedu[i]!= EMPTY_VALUE) slopedu[i+x] = slope[i+x]; 
                        }                              
               }
               
       return(0);     
      }

      //
      //
      //
      //
      //
   
      double alpha = 2.0/(1.0+EmaPeriod);
      for (i=limit; i>=0; i--)
      {
         if (Bars-i<=LwmaPeriod) { slope[i] = 0; ema1[i] = 0; ema2[i] = 0; continue; }            
         slope[i] = (iMA(NULL,0,LwmaPeriod+1,0,MODE_LWMA,LwmaPrice,i)-calcWhatever(LwmaPeriod,i));
         if (slope[i]>0)
               ema1[i] = ema1[i+1]+alpha*(slope[i]-ema1[i+1]);
         else  ema1[i] = ema1[i+1];
         if (slope[i]<0)
               ema2[i] = ema2[i+1]+alpha*(slope[i]-ema2[i+1]);
         else  ema2[i] = ema2[i+1];
         
         //
         //
         //
         //
         //

         slopeuu[i] = EMPTY_VALUE;
         slopeud[i] = EMPTY_VALUE;
         slopedd[i] = EMPTY_VALUE;
         slopedu[i] = EMPTY_VALUE;
            if (slope[i]>ema1[i]) { slopeuu[i] = slope[i]; continue; }
            if (slope[i]>0)       { slopeud[i] = slope[i]; continue; }
            if (slope[i]<ema2[i]) { slopedu[i] = slope[i]; continue; }
            if (slope[i]<0)       { slopedd[i] = slope[i]; continue; }
            
            
   }
return( 0 );
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double calcWhatever( int period, int i)
{
   double Sum  = (period+1)*iMA(NULL,0,1,0,MODE_SMA,LwmaPrice,i+1)+period*iMA(NULL,0,1,0,MODE_SMA,LwmaPrice,i);
   double Sumw = (period+1)+period;
   int j,k;

      //
      //
      //
      //
      //
      
      for (j=1, k=period; j <= period; j++,k-- )
      {
         Sum  += k*iMA(NULL,0,1,0,MODE_SMA,LwmaPrice,i+j+1);
         Sumw += k;
      }

   return( Sum / Sumw );
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}     



